Fixed Xamarin Bug 6148
[mono.git] / mono / tests / Makefile.am
1 SUBDIRS = cas assemblyresolve
2
3 check-local: test
4
5 aotcheck: testaot gshared-aot
6
7 TEST_PROG = ../interpreter/mint
8
9 JITTEST_PROG = $(if $(VALGRIND), valgrind $(VALGRIND_ARGS),) $(if $(SGEN),$(top_builddir)/mono/mini/mono-sgen,$(top_builddir)/mono/mini/mono)
10
11 TEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(TEST_PROG)
12 JITTEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(JITTEST_PROG)
13
14 RUNTIME_ARGS=--config tests-config --optimize=all --debug
15
16 with_mono_path = MONO_PATH=$(mcs_topdir)/class/lib/net_4_5
17 with_mono_path_moonlight = MONO_PATH=$(mcs_topdir)/class/lib/moonlight_raw
18
19 RUNTIME = $(with_mono_path) $(top_builddir)/runtime/mono-wrapper
20 RUNTIME_MOONLIGHT = $(with_mono_path_moonlight) $(top_builddir)/runtime/mono-wrapper
21
22 MKBUNDLE = \
23         PKG_CONFIG_PATH=$(top_builddir):$(PKG_CONFIG_PATH) \
24         $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/mkbundle.exe
25
26 MCS = $(RUNTIME) $(mcs_topdir)/class/lib/build/mcs.exe -unsafe -nowarn:0162 -nowarn:0168 -nowarn:0219 -debug
27 ILASM = $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/ilasm.exe
28
29 BENCHSRC=fib.cs random.cs nested-loops.cs ackermann.cs tight-loop.cs sieve.cs
30
31 STRESS_TESTS_SRC=       \
32         abort-stress-1.cs       \
33         abort-stress-2.cs       \
34         abort-stress-3.cs       \
35         domain-stress.cs        \
36         gchandle-stress.cs      \
37         monitor-stress.cs       \
38         thread-stress.cs        \
39         gc-stress.cs            \
40         exit-stress.cs          \
41         process-stress.cs       \
42         assembly-load-stress.cs
43
44 # Disabled until ?mcs is fixed
45 #       bug-331958.cs
46 BASE_TEST_CS_SRC=               \
47         array-init.cs           \
48         arraylist.cs            \
49         assemblyresolve_event.cs        \
50         assemblyresolve_event3.cs       \
51         checked.cs              \
52         char-isnumber.cs        \
53         create-instance.cs      \
54         field-layout.cs         \
55         pack-layout.cs          \
56         pack-bug.cs             \
57         hash-table.cs           \
58         test-ops.cs             \
59         obj.cs                  \
60         test-dup-mp.cs          \
61         string.cs               \
62         stringbuilder.cs        \
63         switch.cs               \
64         outparm.cs              \
65         delegate.cs             \
66         bitconverter.cs         \
67         exception.cs            \
68         exception2.cs           \
69         exception3.cs           \
70         exception4.cs           \
71         exception5.cs           \
72         exception6.cs           \
73         exception7.cs           \
74         exception8.cs           \
75         exception10.cs          \
76         exception11.cs          \
77         exception12.cs          \
78         exception13.cs          \
79         exception14.cs          \
80         exception15.cs          \
81         exception16.cs          \
82         exception17.cs          \
83         typeload-unaligned.cs   \
84         struct.cs               \
85         valuetype-gettype.cs    \
86         typeof-ptr.cs           \
87         static-constructor.cs   \
88         pinvoke.cs              \
89         pinvoke2.cs             \
90         pinvoke3.cs             \
91         pinvoke11.cs            \
92         pinvoke13.cs            \
93         pinvoke17.cs            \
94         invoke.cs               \
95         invoke2.cs              \
96         runtime-invoke.cs               \
97         invoke-string-ctors.cs          \
98         reinit.cs               \
99         box.cs                  \
100         array.cs                \
101         enum.cs                 \
102         enum2.cs                \
103         property.cs             \
104         enumcast.cs             \
105         assignable-tests.cs     \
106         array-cast.cs           \
107         array-subtype-attr.cs   \
108         cattr-compile.cs        \
109         cattr-field.cs          \
110         cattr-object.cs         \
111         custom-attr.cs          \
112         double-cast.cs          \
113         newobj-valuetype.cs     \
114         arraylist-clone.cs      \
115         setenv.cs               \
116         vtype.cs                \
117         isvaluetype.cs          \
118         iface6.cs               \
119         iface7.cs               \
120         ipaddress.cs            \
121         array-vt.cs             \
122         interface1.cs           \
123         reflection-enum.cs      \
124         reflection-prop.cs      \
125         reflection4.cs          \
126         reflection5.cs          \
127         reflection-const-field.cs \
128         many-locals.cs          \
129         string-compare.cs       \
130         test-prime.cs           \
131         params.cs               \
132         reflection.cs           \
133         interface.cs            \
134         iface.cs                \
135         iface2.cs               \
136         iface3.cs               \
137         iface4.cs               \
138         iface-large.cs          \
139         virtual-method.cs       \
140         intptrcast.cs           \
141         indexer.cs              \
142         stream.cs               \
143         console.cs              \
144         shift.cs                \
145         jit-int.cs              \
146         jit-uint.cs             \
147         jit-long.cs             \
148         long.cs                 \
149         jit-ulong.cs            \
150         jit-float.cs            \
151         pop.cs                  \
152         time.cs                 \
153         appdomain.cs        \
154         appdomain1.cs           \
155         appdomain2.cs           \
156         appdomain-client.cs     \
157         appdomain-unload.cs \
158         appdomain-async-invoke.cs       \
159         loader.cs       \
160         pointer.cs              \
161         hashcode.cs             \
162         delegate1.cs            \
163         delegate2.cs            \
164         delegate3.cs            \
165         delegate5.cs            \
166         delegate6.cs            \
167         delegate7.cs            \
168         delegate8.cs            \
169         delegate9.cs            \
170         remoting1.cs            \
171         remoting2.cs            \
172         remoting3.cs            \
173         remoting4.cs            \
174         remoting5.cs            \
175         largeexp.cs             \
176         largeexp2.cs            \
177         marshalbyref1.cs        \
178         static-ctor.cs          \
179         inctest.cs              \
180         bound.cs                \
181         array-invoke.cs         \
182         test-arr.cs             \
183         decimal.cs              \
184         decimal-array.cs        \
185         marshal.cs              \
186         marshal1.cs             \
187         marshal2.cs             \
188         marshal3.cs             \
189         marshal5.cs             \
190         marshal6.cs             \
191         marshal7.cs             \
192         marshal8.cs             \
193         marshal9.cs             \
194         marshalbool.cs          \
195         marshal-valuetypes.cs   \
196         test-byval-in-struct.cs \
197         thread.cs               \
198         thread5.cs              \
199         thread6.cs              \
200         thread-static.cs        \
201         thread-static-init.cs   \
202         context-static.cs       \
203         float-pop.cs            \
204         interfacecast.cs        \
205         array3.cs               \
206         classinit.cs            \
207         classinit2.cs           \
208         synchronized.cs         \
209         async_read.cs           \
210         threadpool.cs           \
211         threadpool1.cs          \
212         threadpool-exceptions1.cs \
213         threadpool-exceptions2.cs \
214         threadpool-exceptions3.cs \
215         threadpool-exceptions4.cs \
216         threadpool-exceptions5.cs \
217         threadpool-exceptions6.cs \
218         threadpool-exceptions7.cs \
219         base-definition.cs      \
220         bug-27420.cs            \
221         bug-47295.cs            \
222         bug-46781.cs            \
223         bug-48015.cs            \
224         bug-42136.cs            \
225         bug-59286.cs            \
226         bug-70561.cs            \
227         bug-78311.cs            \
228         bug-78653.cs            \
229         bug-78656.cs            \
230         bug-77127.cs            \
231         bug-323114.cs           \
232         interlocked.cs          \
233         cross-domain.cs         \
234         appdomain-exit.cs       \
235         delegate-async-exit.cs  \
236         delegate-delegate-exit.cs       \
237         delegate-exit.cs        \
238         finalizer-abort.cs      \
239         finalizer-exception.cs  \
240         finalizer-exit.cs       \
241         finalizer-thread.cs     \
242         main-exit.cs    \
243         main-returns-abort-resetabort.cs        \
244         main-returns-background-abort-resetabort.cs     \
245         main-returns-background-resetabort.cs   \
246         main-returns-background.cs      \
247         main-returns-background-change.cs       \
248         main-returns.cs         \
249         subthread-exit.cs       \
250         desweak.cs              \
251         cominterop.cs           \
252         exists.cs               \
253         handleref.cs    \
254         transparentproxy.cs \
255         dbnull-missing.cs       \
256         test-type-ctor.cs       \
257         soft-float-tests.cs     \
258         thread-exit.cs          \
259         finalize-parent.cs      \
260         assemblyresolve_event2.2.cs     \
261         interlocked-2.2.cs      \
262         pinvoke-2.2.cs          \
263         bug-78431.2.cs          \
264         bug-79684.2.cs          \
265         catch-generics.2.cs     \
266         event-get.2.cs          \
267         safehandle.2.cs         \
268         stackframes-async.2.cs          \
269         module-cctor-loader.2.cs        \
270         generics-invoke-byref.2.cs      \
271         generic-signature-compare.2.cs  \
272         generics-sharing.2.cs   \
273         shared-generic-methods.2.cs     \
274         shared-generic-synchronized.2.cs        \
275         generic-inlining.2.cs   \
276         generic-initobj.2.cs    \
277         generic-delegate.2.cs   \
278         generic-sizeof.2.cs     \
279         generic-virtual.2.cs    \
280         generic-interface-methods.2.cs  \
281         generic-array-type.2.cs \
282         generic-method-patching.2.cs    \
283         generic-static-methods.2.cs     \
284         generic-null-call.2.cs  \
285         generic-special.2.cs    \
286         generic-exceptions.2.cs \
287         generic-virtual2.2.cs   \
288         generic-valuetype-interface.2.cs        \
289         generic-getgenericarguments.2.cs        \
290         generic-type-builder.2.cs       \
291         generic-synchronized.2.cs       \
292         generic-delegate-ctor.2.cs      \
293         generic-array-iface-set.2.cs    \
294         generic-typedef.2.cs    \
295         generic-marshalbyref.2.cs       \
296         generic-xdomain.2.cs    \
297         bug-431413.2.cs \
298         bug-459285.2.cs \
299         generic-virtual-invoke.2.cs     \
300         bug-461198.2.cs \
301         generic-sealed-virtual.2.cs     \
302         generic-system-arrays.2.cs      \
303         generic-stack-traces.2.cs       \
304         generic-stack-traces2.2.cs      \
305         bug-472600.2.cs \
306         recursive-generics.2.cs \
307         bug-473482.2.cs \
308         bug-473999.2.cs \
309         bug-479763.2.cs \
310         bug-616463.cs   \
311         bug-80392.2.cs          \
312         dynamic-method-access.2.cs      \
313         dynamic-method-finalize.2.cs    \
314         bug-82194.2.cs  \
315         anonarray.2.cs  \
316         ienumerator-interfaces.2.cs     \
317         array-enumerator-ifaces.2.cs    \
318         generic_type_definition_encoding.2.cs \
319         generic_type_definition.2.cs    \
320         bug-333798.2.cs         \
321         bug-333798-tb.2.cs              \
322         bug-335131.2.cs         \
323         bug-322722_patch_bx.2.cs                \
324         bug-348522.2.cs         \
325         bug-340662_bug.cs       \
326         bug-322722_dyn_method_throw.2.cs        \
327         bug-389886-2.cs \
328         bug-325283.2.cs \
329         thunks.cs \
330         winx64structs.cs \
331         bug-349190.2.cs \
332         nullable_boxing.2.cs    \
333         valuetype-equals.cs     \
334         custom-modifiers.2.cs   \
335         bug-382986.cs   \
336         test-inline-call-stack.cs       \
337         bug-324535.cs   \
338         modules.cs      \
339         bug-81673.cs    \
340         bug-81691.cs    \
341         bug-80307.cs    \
342         bug-415577.cs   \
343         filter-stack.cs \
344         vararg2.cs      \
345         bug-389886-sre-generic-interface-instances.cs   \
346         bug-461867.cs   \
347         bug-461941.cs   \
348         bug-461261.cs   \
349         bug-400716.cs   \
350         bug-462592.cs   \
351         bug-459094.cs   \
352         generic-unloading.2.cs  \
353         generic-unloading-sub.2.cs      \
354         bug-467456.cs   \
355         appdomain-unload-callback.cs    \
356         bug-508538.cs   \
357         bug-472692.2.cs         \
358         gchandles.cs    \
359         interlocked-3.cs        \
360         interlocked-4.2.cs      \
361         finalizer-wait.cs       \
362         critical-finalizers.cs  \
363         appdomain-thread-abort.cs \
364         xdomain-threads.cs      \
365         w32message.cs   \
366         bug-544446.cs   \
367         gc-altstack.cs  \
368         large-gc-bitmap.cs      \
369         bug-561239.cs   \
370         bug-562150.cs   \
371         bug-575941.cs   \
372         bug-599469.cs   \
373         bug-389886-3.cs \
374         monitor.cs      \
375         dynamic-method-resurrection.cs  \
376         bug-666008.cs   \
377         bug-685908.cs   \
378         sgen-long-vtype.cs      \
379         delegate-invoke.cs      \
380         bug-696593.cs   \
381         bug-705140.cs   \
382         bug-1147.cs     \
383         mono-path.cs    \
384         bug-bxc-795.cs  \
385         bug-3903.cs     \
386         async-with-cb-throws.cs \
387         appdomain-unload-doesnot-raise-pending-events.cs        \
388         bug-6148.cs
389
390 TEST_CS_SRC_DIST=       \
391         $(BASE_TEST_CS_SRC)     \
392         async-exc-compilation.cs \
393         filter-stack.cs \
394         finally_guard.cs
395
396 TEST_CS_SRC_GEN = \
397         runtime-invoke.gen.cs \
398         imt_big_iface_test.cs
399
400 if AMD64
401 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
402 # #651684
403 PLATFORM_DISABLED_TESTS = finally_guard.exe
404 else
405 if X86
406 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
407 else
408 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN)
409 endif
410 endif
411
412 if IA64
413 TEST_CS_SRC+=async-exc-compilation.cs filter-stack.cs
414 # bug #319249
415 PLATFORM_DISABLED_TESTS=exception17.exe
416 PLATFORM_DISABLED_TESTS+=winx64structs.exe
417 endif
418
419 if X86
420
421 if HOST_WIN32
422 PLATFORM_DISABLED_TESTS=async-exc-compilation.exe finally_guard.exe
423 endif
424
425 endif
426
427 if POWERPC
428 # bug #71274
429 PLATFORM_DISABLED_TESTS=finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
430 endif
431
432 if ARM
433 PLATFORM_DISABLED_TESTS=filter-stack.exe
434 endif
435
436 if MIPS
437 # monitor.exe is racy
438 PLATFORM_DISABLED_TESTS=filter-stack.exe monitor.exe
439 endif
440
441 if S390x
442 PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe
443 #PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe exception17.exe
444 endif
445
446 # The two finalizer tests only work under sgen
447 # gc-altstack.exe fails under boehm because it has no support for altstack
448 # bug-459094.exe creates an extremely deep directory tree
449 # delegate-invoke.exe depends on 929c6bc9b6d76a273f251e6f5dfacac36e9c38bd which was
450 # reverted.
451 # generic_type_definition.2.exe depends on COMPILER_ACCESS which is no longer supported.
452 DISABLED_TESTS=                 \
453         delegate-async-exception.exe    \
454         bug-348522.2.exe        \
455         finalizer-wait.exe      \
456         critical-finalizers.exe \
457         gc-altstack.exe \
458         bug-459094.exe \
459         delegate-invoke.exe \
460         generic_type_definition.2.exe \
461         $(PLATFORM_DISABLED_TESTS)
462
463 DISABLED_TESTS_WRENCH=  \
464         $(DISABLED_TESTS)       \
465         $(PLATFORM_DISABLED_TESTS_WRENCH)       \
466         main-returns-background-resetabort.exe \
467         main-returns-background-abort-resetabort.exe    \
468         main-returns-background.exe     \
469         thread6.exe     \
470         assemblyresolve_event3.exe \
471         delegate2.exe   \
472         finally_guard.exe       \
473         finalizer-abort.exe     \
474         finalizer-exit.exe      \
475         finalizer-thread.exe \
476         appdomain-async-invoke.exe
477
478 AOT_DISABLED_TESTS=constraints-load.exe
479
480 # These only compile with MS CSC
481 TEST_CSC_SRC=                   \
482         vararg.cs
483
484 TEST_IL_SRC=                    \
485         field-access.il         \
486         method-access.il        \
487         ldftn-access.il         \
488         cpblkTest.il            \
489         vbinterface.il          \
490         calliTest.il            \
491         ckfiniteTest.il         \
492         fault-handler.il                \
493         locallocTest.il         \
494         initblkTest.il          \
495         qt-instance.il          \
496         vararg.il               \
497         bug-29859.il            \
498         bug-78549.il            \
499         static-fields-nonconst.il       \
500         reload-at-bb-end.il     \
501         test-enum-indstoreil.il \
502         filter-bug.il           \
503         even-odd.il             \
504         bug-82022.il    \
505         vt-sync-method.il       \
506         enum_types.il   \
507         invalid-token.il        \
508         call_missing_method.il  \
509         call_missing_class.il   \
510         ldfld_missing_field.il  \
511         ldfld_missing_class.il  \
512         find-method.2.il        \
513         bug-79215.2.il  \
514         bug-79956.2.il  \
515         bug-327438.2.il \
516         bug-387274.2.il \
517         bug-426309.2.il \
518         ldtoken_with_byref_typespec.2.il \
519         resolve_method_bug.2.il \
520         resolve_field_bug.2.il \
521         resolve_type_bug.2.il   \
522         generics-sharing-other-exc.2.il \
523         generic-ldobj.2.il      \
524         generic-mkrefany.2.il   \
525         generic-refanyval.2.il  \
526         generic-ldtoken.2.il    \
527         generic-ldtoken-method.2.il     \
528         generic-ldtoken-field.2.il      \
529         generic-tailcall.2.il   \
530         generic-tailcall2.2.il  \
531         generic-array-exc.2.il  \
532         generic-valuetype-newobj2.2.il  \
533         generic-valuetype-newobj.2.il   \
534         generic-constrained.2.il        \
535         generic-type-load-exception.2.il        \
536         bug-81466.il    \
537         bug457574.il    \
538         bug445361.il    \
539         bug-463303.il   \
540         bug469742.2.il  \
541         bug-528055.il   \
542         constraints-load.il     \
543         array_load_exception.il \
544         bug-481403.il   \
545         interface-with-static-method.il \
546         bug-515884.il   \
547         bug-633291.il   \
548         delegate-with-null-target.il    \
549         bug-318677.il
550
551 # pre-requisite test sources: files that are not test themselves
552 # but that need to be compiled
553 PREREQ_IL_SRC=event-il.il module-cctor.il
554 PREREQ_CS_SRC=
555 PREREQ_IL_DLL_SRC=event-il.il module-cctor.il
556 PREREQ_CS_DLL_SRC=
557
558 PREREQSI_IL=$(PREREQ_IL_SRC:.il=.exe)
559 PREREQSI_CS=$(PREREQ_CS_SRC:.cs=.exe)
560 TESTSI_CS=$(TEST_CS_SRC:.cs=.exe)
561 TESTSI_IL=$(TEST_IL_SRC:.il=.exe)
562 TESTBS=$(BENCHSRC:.cs=.exe)
563 STRESS_TESTS=$(STRESS_TESTS_SRC:.cs=.exe)
564
565 EXTRA_DIST=test-driver $(TEST_CS_SRC_DIST) $(TEST_IL_SRC) \
566         $(BENCHSRC) $(STRESS_TESTS_SRC) stress-runner.pl $(PREREQ_IL_SRC) $(PREREQ_CS_SRC)
567
568 %.exe: %.il
569         $(ILASM) -out:$@ $<
570
571 %.exe: %.cs TestDriver.dll
572         $(MCS) -r:TestDriver.dll -out:$@ $<
573
574 # mkbundle works on ppc, but the pkg-config POC doesn't when run with make test
575 if POWERPC
576 test_platform:
577 else
578 # Can't use mkbundle on win32 since there is no static build there
579 # Can't run test-unhandled-exception on Windows because of all the debug popups...
580 if HOST_WIN32
581 test_platform:
582 else
583 # mkbundle uses the installed mono-2.pc so it won't work if there is no system mono
584 #test_platform: testbundle test-iomap-regression
585 test_platform:  test-iomap-regression
586 endif
587 endif
588
589 if X86
590 if HOST_WIN32
591 else
592 test_platform: test-eglib-remap
593 endif
594 endif
595
596 # Target to precompile the test executables
597 tests: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS) $(GSHARED_TESTS)
598
599 #
600 # Test that no symbols are missed in eglib-remap.h
601 #
602 OK_G_SYMBOLS='g_list\|g_slist\|g_concat_dir_and_file'
603 test-eglib-remap:
604         @echo "Testing eglib remap..."
605         @if which nm > /dev/null; then if nm $(top_builddir)/mono/mini/mono | grep -v $(OK_G_SYMBOLS) | grep 't g_'; then exit 1; else exit 0; fi; fi
606
607 #
608 # Tests that the internals in mono/io-layer/messages.c are ok by triggering the 
609 # code that checks that the table is properly sorted
610 #
611 test-messages: w32message.exe
612         > test_messages.zero
613         $(with_mono_path) $(JITTEST_PROG_RUN) w32message.exe >& w32message.allout && cmp test_messages.zero w32message.allout
614
615 if MOONLIGHT
616 test_2_1 : test-coreclr-security
617 else
618 test_2_1 :
619 endif
620
621 if AMD64
622 test-sgen : sgen-tests
623 else
624 if X86
625 test-sgen : sgen-tests
626 else
627 if ARM
628 test-sgen : sgen-tests
629 else
630 if S390x
631 test-sgen : sgen-regular-tests
632 endif
633 endif
634 endif
635 endif
636
637 test: assemblyresolve/test/asm.dll testjit test-type-load test-generic-sharing test_platform test_2_1 test-messages
638 test-wrench: assemblyresolve/test/asm.dll testjit-wrench test-generic-sharing test-type-load test_platform test_2_1 test-process-exit test-sgen test-messages rm-empty-logs
639
640 # Remove empty .stdout and .stderr files for wrench
641 rm-empty-logs:
642         @echo "Removing empty logs..."
643         @find . '(' -name "*.stdout" -o -name "*.stderr" ')' -empty -exec rm {} \;
644
645 assemblyresolve/test/asm.dll:
646         $(MAKE) -C assemblyresolve prereq
647
648 TestDriver.dll:
649         $(MCS) -target:library -out:$@ $(srcdir)/../mini/TestDriver.cs
650
651 test_cs: $(TEST_PROG) $(TESTSI_CS) libtest.la
652         @failed=0; \
653         passed=0; \
654         for i in $(TESTSI_CS); do       \
655                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS); \
656                 then \
657                         passed=`expr $${passed} + 1`; \
658                 else \
659                         if [ $$? = 2 ]; then break; fi; \
660                         failed=`expr $${failed} + 1`; \
661                 fi \
662         done; \
663         echo; echo ".cs: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
664
665 test_il: $(TEST_PROG) $(TESTSI_IL) libtest.la
666         @failed=0; \
667         passed=0; \
668         for i in $(TESTSI_IL); do       \
669                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$(DISABLED_TESTS)" $(RUNTIME_ARGS); \
670                 then \
671                         passed=`expr $${passed} + 1`; \
672                 else \
673                         if [ $$? = 2 ]; then break; fi; \
674                         failed=`expr $${failed} + 1`; \
675                 fi \
676         done; \
677         echo; echo ".il: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
678
679 testb: $(TEST_PROG) $(TESTBS)
680         for i in $(TESTBS); do  \
681                 $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS);     \
682         done
683
684 runtest-wrench: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
685         @failed=0; \
686         passed=0; \
687         failed_tests="";\
688         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
689                 rm -f $${i}.so; \
690                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
691                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS_WRENCH)' $(RUNTIME_ARGS); \
692                 then \
693                         passed=`expr $${passed} + 1`; \
694                 else \
695                         if [ $$? = 2 ]; then break; fi; \
696                         failed=`expr $${failed} + 1`; \
697                         failed_tests="$${failed_tests} $$i"; \
698                 fi \
699         done; \
700         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
701         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
702           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
703
704 runtest-managed-wrench: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
705         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS_WRENCH)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
706
707 testjit-wrench:
708         @if test x$(M) != x; then $(MAKE) runtest-managed-wrench; else $(MAKE) runtest-wrench; fi
709
710 runtest: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
711         @failed=0; \
712         passed=0; \
713         failed_tests="";\
714         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
715                 rm -f $${i}.so; \
716                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
717                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS); \
718                 then \
719                         passed=`expr $${passed} + 1`; \
720                 else \
721                         if [ $$? = 2 ]; then break; fi; \
722                         failed=`expr $${failed} + 1`; \
723                         failed_tests="$${failed_tests} $$i"; \
724                 fi \
725         done; \
726         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
727         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
728           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
729
730 runtest-managed: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
731         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
732
733 testjit:
734         @if test x$(M) != x; then $(MAKE) runtest-managed; else $(MAKE) runtest; fi
735
736 testaot:
737         @$(MAKE) AOT=1 runtest
738
739 testtrace:
740         @$(MAKE) RUNTIME_ARGS="$${RUNTIME_ARGS} --trace" runtest
741
742 testinterp:
743         @$(MAKE) JITTEST_PROG_RUN="$(TEST_PROG_RUN)" runtest
744
745 testjitspeed: $(JITTEST_PROG) $(TESTBS)
746         for i in $(TESTBS); do  \
747                 echo $$i;       \
748                 time $(JITTEST_PROG) $$i;       \
749         done
750
751 test-iomap-regression: exists.cs
752         @$(MCS) $(srcdir)/exists.cs -out:exists.exe
753         @echo "Testing exists.exe..."
754         @MONO_IOMAP=all $(RUNTIME) exists.exe
755
756 stresstest: $(STRESS_TESTS)
757         @failed=0; \
758         passed=0; \
759         failed_tests="";\
760         for i in $(STRESS_TESTS); do    \
761                 if $(srcdir)/stress-runner.pl $$i ../mini/mono $(RUNTIME_ARGS); \
762                 then \
763                         passed=`expr $${passed} + 1`; \
764                 else \
765                         if [ $$? = 2 ]; then break; fi; \
766                         failed=`expr $${failed} + 1`; \
767                         failed_tests="$${failed_tests} $$i"; \
768                 fi \
769         done; \
770         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
771         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
772           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
773
774 testbundle: console.exe
775         @echo "Testing mkbundle..."
776         @$(MKBUNDLE) --static console.exe > mkbundle.stdout
777         @$(with_mono_path) MONO_CFG_DIR=$(mono_cfg_dir) MONO_SHARED_DIR=$(mono_build_root)/runtime ./a.out >> mkbundle.stdout
778         @- rm -rf a.out
779
780 EXTRA_DIST += load-missing.il t-missing.cs load-exceptions.cs
781 test-type-load: TestDriver.dll
782         @$(ILASM) /dll /output:load-missing.dll $(srcdir)/load-missing.il > /dev/null
783         @$(MCS) -t:library -out:t.dll -d:FOUND $(srcdir)/t-missing.cs
784         @$(MCS) -r:TestDriver.dll -r:load-missing.dll -r:t.dll -out:load-exceptions.exe $(srcdir)/load-exceptions.cs
785         @$(MCS) -t:library -out:t.dll $(srcdir)/t-missing.cs
786         @echo "Testing load-exception.exe..."
787         @$(RUNTIME) load-exceptions.exe > load-exceptions.exe.stdout 2> load-exceptions.exe.stderr
788
789
790 EXTRA_DIST += sgen-bridge.cs sgen-descriptors.cs sgen-gshared-vtype.cs sgen-bridge-major-fragmentation.cs
791
792 SGEN_TESTS =    \
793         sgen-descriptors.exe    \
794         sgen-gshared-vtype.exe
795
796 sgen-regular-tests: $(SGEN_TESTS)
797         @for fn in $+ ; do      \
798                 echo "Testing $$fn ...";        \
799                 MONO_GC_PARAMS=major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1; \
800                 MONO_ENV_OPTIONS="--gc=sgen"                                    $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1; \
801                 MONO_GC_PARAMS=major=marksweep-par,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;     \
802                 MONO_GC_PARAMS=minor=split MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;     \
803                 MONO_GC_PARAMS=major=marksweep,concurrent-sweep MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;    \
804                 MONO_GC_PARAMS=minor=split,major=marksweep,concurrent-sweep MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;        \
805                 MONO_GC_PARAMS=major=marksweep-par,minor=split,alloc-ratio=95 MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;      \
806                 MONO_GC_PARAMS=minor=split,alloc-ratio=95 MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;      \
807         done
808
809
810 sgen-tests: sgen-regular-tests sgen-bridge.exe sgen-bridge-major-fragmentation.exe
811         @echo "Testing sgen-bridge.exe ...";    \
812         MONO_GC_PARAMS=bridge=Bridge MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge.exe > sgen-bridge.exe.stdout 2> sgen-bridge.exe.stderr || exit 1;      \
813         MONO_GC_PARAMS=bridge=Bridge,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge.exe > sgen-bridge.exe.stdout 2> sgen-bridge.exe.stderr || exit 1;  \
814         echo "Testing sgen-bridge-major-fragmentation.exe ..."; \
815         MONO_GC_PARAMS=bridge=Bridge MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge-major-fragmentation.exe > sgen-bridge-major-fragmentation.exe.stdout 2> sgen-bridge-major-fragmentation.exe.stderr || exit 1;  \
816         MONO_GC_PARAMS=bridge=Bridge,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge-major-fragmentation.exe > sgen-bridge-major-fragmentation.exe.stdout 2> sgen-bridge-major-fragmentation.exe.stderr || exit 1;
817
818
819 # Generated tests for runtime invoke
820 EXTRA_DIST += gen-runtime-invoke.cs
821 runtime-invoke.gen.exe: TestDriver.dll gen-runtime-invoke.exe
822         $(RUNTIME) gen-runtime-invoke.exe > runtime-invoke.gen.cs
823         $(MCS) -out:runtime-invoke.gen.exe -r:TestDriver.dll runtime-invoke.gen.cs
824
825 EXTRA_DIST += make-imt-test.cs
826 imt_big_iface_test.exe: TestDriver.dll make-imt-test.exe
827         $(RUNTIME) make-imt-test.exe > imt_big_iface_test.cs
828         $(MCS) -out:imt_big_iface_test.exe -r:TestDriver.dll imt_big_iface_test.cs
829
830 EXTRA_DIST += test-inline-call-stack-library.cs test-inline-call-stack.cs
831 test-inline-call-stack-library.dll: TestDriver.dll $(srcdir)/test-inline-call-stack-library.cs
832         $(MCS) -t:library -out:test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack-library.cs
833 test-inline-call-stack.exe: TestDriver.dll test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack.cs
834         $(MCS) -r:TestDriver.dll -r:test-inline-call-stack-library.dll -out:test-inline-call-stack.exe $(srcdir)/test-inline-call-stack.cs
835
836 EXTRA_DIST += unhandled-exception-base-configuration.config
837 EXTRA_DIST += unhandled-exception-legacy-configuration.config
838 EXTRA_DIST += appdomain-unload.exe.config
839 EXTRA_DIST += unhandled-exception-test-case.2.cs
840 EXTRA_DIST += unhandled-exception-test-runner.2.cs
841 unhandled-exception-test-case.1.cs: unhandled-exception-test-case.2.cs
842         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case.1.cs
843 unhandled-exception-test-case-legacy.1.cs: unhandled-exception-test-case.1.cs
844         cp unhandled-exception-test-case.1.cs unhandled-exception-test-case-legacy.1.cs
845 unhandled-exception-test-case-legacy.2.cs: unhandled-exception-test-case.2.cs
846         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case-legacy.2.cs
847 unhandled-exception-config_files: unhandled-exception-base-configuration.config unhandled-exception-legacy-configuration.config
848         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.1.exe.config
849         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.2.exe.config
850         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.1.exe.config
851         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.2.exe.config
852 unhandled-exception-test-case.1.exe: unhandled-exception-test-case.1.cs
853         $(MCS) /debug unhandled-exception-test-case.1.cs
854 unhandled-exception-test-case-legacy.1.exe: unhandled-exception-test-case-legacy.1.cs
855         $(MCS) /debug unhandled-exception-test-case-legacy.1.cs
856 unhandled-exception-test-case.2.exe: unhandled-exception-test-case.2.cs
857         $(MCS) /debug unhandled-exception-test-case.2.cs
858 unhandled-exception-test-case-legacy.2.exe: unhandled-exception-test-case-legacy.2.cs
859         $(MCS) /debug unhandled-exception-test-case-legacy.2.cs
860 unhandled-exception-test-runner.2.exe: unhandled-exception-test-runner.2.cs
861         $(MCS) /debug unhandled-exception-test-runner.2.cs
862
863 test-unhandled-exception: unhandled-exception-test-runner.2.exe unhandled-exception-config_files unhandled-exception-test-case.1.exe unhandled-exception-test-case-legacy.1.exe  unhandled-exception-test-case.2.exe unhandled-exception-test-case-legacy.2.exe
864         $(RUNTIME) unhandled-exception-test-runner.2.exe RUNTIME:../mini/mono,GTC:F
865
866 # We use 'test-support-files' to handle an ordering issue between the 'mono/' and 'runtime/' directories
867 bug-80307.exe: $(srcdir)/bug-80307.cs
868         $(MCS) -r:System.Web -out:$@ $(srcdir)/bug-80307.cs
869         cd $(top_builddir)/runtime && $(MAKE) test-support-files
870
871 EXTRA_DIST += bug-81673-interface.cs
872 bug-81673.exe bug-81673-interface.dll: $(srcdir)/bug-81673.cs $(srcdir)/bug-81673-interface.cs
873         $(MCS) -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
874         $(MCS) -out:bug-81673.exe -r:bug-81673-interface.dll $(srcdir)/bug-81673.cs
875         $(MCS) -define:WITH_STOP -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
876
877 EXTRA_DIST += bug-81691-a.cs bug-81691-b.cs
878 bug-81691.exe bug-81691-b.dll: $(srcdir)/bug-81691.cs $(srcdir)/bug-81691-a.cs $(srcdir)/bug-81691-b.cs
879         $(MCS) -target:library -out:bug-81691-a.dll $(srcdir)/bug-81691-a.cs
880         $(MCS) -target:library -out:bug-81691-b.dll -r:bug-81691-a.dll $(srcdir)/bug-81691-b.cs
881         $(MCS) -r:bug-81691-b.dll -out:bug-81691.exe $(srcdir)/bug-81691.cs
882         rm -f bug-81691-a.dll
883 bug-81691.exe: bug-81691-b.dll
884
885 EXTRA_DIST += bug-81466-lib.il
886 bug-81466-lib.dll: bug-81466-lib.il
887         $(ILASM) /dll /output:bug-81466-lib.dll $(srcdir)/bug-81466-lib.il
888 bug-81466.exe: bug-81466.il bug-81466-lib.dll
889         $(ILASM) /exe /output:bug-81466.exe $(srcdir)/bug-81466.il
890
891 EXTRA_DIST += bug-324535-il.il
892 bug-324535-il.dll : bug-324535-il.il
893         $(ILASM) /dll /output:bug-324535-il.dll $(srcdir)/bug-324535-il.il
894 bug-324535.exe : bug-324535.cs bug-324535-il.dll
895         $(MCS) -r:bug-324535-il.dll -out:bug-324535.exe $(srcdir)/bug-324535.cs
896
897 EXTRA_DIST += custom-modifiers.2.cs custom-modifiers-lib.il
898 custom-modifiers-lib.dll: custom-modifiers-lib.il
899         $(ILASM) /dll /output:custom-modifiers-lib.dll $(srcdir)/custom-modifiers-lib.il
900 custom-modifiers.2.exe: custom-modifiers.2.cs custom-modifiers-lib.dll
901         $(MCS) -r:custom-modifiers-lib.dll -out:custom-modifiers.2.exe $(srcdir)/custom-modifiers.2.cs
902
903 EXTRA_DIST += bug-382986-lib.cs
904 bug-382986-lib.dll: bug-382986-lib.cs
905         $(MCS) -target:library -out:$@ $(srcdir)/bug-382986-lib.cs
906 bug-382986.exe: bug-382986.cs bug-382986-lib.dll
907         $(MCS) -out:$@ -r:bug-382986-lib.dll $(srcdir)/bug-382986.cs
908
909 EXTRA_DIST += coreclr-security.cs
910
911 if MOONLIGHT
912 coreclr-security.exe : coreclr-security.cs
913         $(SMCS) -out:coreclr-security.exe $(srcdir)/coreclr-security.cs
914
915 test-coreclr-security : coreclr-security.exe
916         @echo "Testing coreclr-security.exe..."
917         @$(RUNTIME_MOONLIGHT) --security=core-clr-test coreclr-security.exe
918 endif
919
920 EXTRA_DIST += generic-unboxing.2.il
921 generic-unboxing.2.dll : generic-unboxing.2.il
922         $(ILASM) /dll /output:generic-unboxing.2.dll $(srcdir)/generic-unboxing.2.il
923
924 EXTRA_DIST += generic-boxing.2.il
925 generic-boxing.2.dll : generic-boxing.2.il generic-unboxing.2.dll
926         $(ILASM) /dll /output:generic-boxing.2.dll $(srcdir)/generic-boxing.2.il
927
928 EXTRA_DIST += generic-unbox.2.cs
929 generic-unbox.2.exe : generic-unbox.2.cs generic-unboxing.2.dll
930         $(MCS) -r:generic-unboxing.2.dll -out:$@ $(srcdir)/generic-unbox.2.cs
931
932 EXTRA_DIST += generic-box.2.cs
933 generic-box.2.exe : generic-box.2.cs generic-unboxing.2.dll generic-boxing.2.dll
934         $(MCS) -r:generic-unboxing.2.dll,generic-boxing.2.dll -out:$@ $(srcdir)/generic-box.2.cs
935
936 EXTRA_DIST += generic-delegate2.2.cs generic-delegate2-lib.2.il
937 generic-delegate2-lib.2.dll : generic-delegate2-lib.2.il
938         $(ILASM) /dll /output:$@ $(srcdir)/generic-delegate2-lib.2.il
939 generic-delegate2.2.exe : generic-delegate2.2.cs generic-delegate2-lib.2.dll
940         $(MCS) -r:generic-delegate2-lib.2.dll -out:$@ $(srcdir)/generic-delegate2.2.cs
941
942 bug-3903.exe: bug-3903.cs
943         $(MCS) -sdk:2 $(srcdir)/bug-3903.cs -out:$@
944
945 gshared: test-generic-sharing
946
947 gshared-aot:
948         @$(MAKE) AOT=1 gshared
949
950 GSHARED_TESTS = \
951                 generics-sharing.2.exe shared-generic-methods.2.exe     \
952                 shared-generic-synchronized.2.exe generic-initobj.2.exe         \
953                 generics-sharing-other-exc.2.exe generic-box.2.exe              \
954                 generic-unbox.2.exe generic-delegate.2.exe generic-sizeof.2.exe \
955                 generic-ldobj.2.exe generic-mkrefany.2.exe                      \
956                 generic-refanyval.2.exe generic-ldtoken.2.exe                   \
957                 generic-ldtoken-method.2.exe  generic-ldtoken-field.2.exe       \
958                 generic-virtual.2.exe generic-tailcall.2.exe                    \
959                 generic-interface-methods.2.exe generic-array-type.2.exe        \
960                 generic-method-patching.2.exe generic-static-methods.2.exe      \
961                 generic-null-call.2.exe generic-tailcall2.2.exe                 \
962                 generic-array-exc.2.exe generic-special.2.exe                   \
963                 generic-exceptions.2.exe generic-delegate2.2.exe                \
964                 generic-virtual2.2.exe generic-valuetype-interface.2.exe        \
965                 generic-valuetype-newobj.2.exe generic-valuetype-newobj2.2.exe  \
966                 generic-getgenericarguments.2.exe generic-type-builder.2.exe    \
967                 generic-synchronized.2.exe generic-delegate-ctor.2.exe          \
968                 generic-constrained.2.exe bug-431413.2.exe                      \
969                 generic-virtual-invoke.2.exe generic-typedef.2.exe              \
970                 generic-marshalbyref.2.exe bug-459285.2.exe bug-461198.2.exe    \
971                 generic-sealed-virtual.2.exe generic-system-arrays.2.exe        \
972                 generic-stack-traces.2.exe generic-stack-traces2.2.exe          \
973                 bug-472600.2.exe bug-473482.2.exe bug-473999.2.exe              \
974                 bug-479763.2.exe generic-xdomain.2.exe                          \
975                 generic-type-load-exception.2.exe bug-616463.exe        \
976                 bug-1147.exe
977
978 test-generic-sharing-normal: $(GSHARED_TESTS)
979         @for fn in $+ ; do      \
980                 echo "Testing $$fn ...";        \
981                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared                $$fn > $$fn.stdout || exit 1;     \
982                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,shared         $$fn > $$fn.stdout || exit 1;     \
983                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline        $$fn > $$fn.stdout || exit 1;     \
984                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline,shared $$fn > $fn.stdout || exit 1;      \
985                 if [ x$(AOT) = x1 ]; then MONO_GENERIC_SHARING=all $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $$fn > /dev/null || exit 1; MONO_GENERIC_SHARING=all $(RUNTIME) $$fn > $$fn.stdout || exit 1; fi; \
986         done
987
988 test-generic-sharing-managed: test-runner.exe $(GSHARED_TESTS)
989         @$(RUNTIME) ./test-runner.exe -j a --opt-sets "gshared gshared,shared gshared,-inline gshared,-inline,shared" $(GSHARED_TESTS)
990
991 test-generic-sharing:
992         @if test x$(M) != x; then $(MAKE) test-generic-sharing-managed; else $(MAKE) test-generic-sharing-normal; fi
993
994 EXTRA_DIST += async-exceptions.cs
995 async-exceptions.exe : async-exceptions.cs
996         $(MCS) -out:async-exceptions.exe $(srcdir)/async-exceptions.cs
997 test-async-exceptions : async-exceptions.exe
998         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:foo $$i async-exceptions.exe || exit 1; done
999         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:bar $$i async-exceptions.exe || exit 1; done
1000
1001 EXTRA_DIST += modules.cs modules-m1.cs
1002 modules-m1.netmodule: modules-m1.cs
1003         $(MCS) -out:$@ /target:module $(srcdir)/modules-m1.cs
1004 modules.exe: modules.cs modules-m1.netmodule TestDriver.dll
1005         $(MCS) -out:$@ /addmodule:modules-m1.netmodule -r:TestDriver.dll $(srcdir)/modules.cs
1006
1007 # Useful if mono is compiled with --enable-shared=no
1008 patch-libtool:
1009         cp "../../libtool" .
1010         sed -e 's,build_libtool_libs=no,build_libtool_libs=yes,g' libtool > 2; mv 2 libtool
1011         sed -e 's,LIBTOOL =,LIBTOOL2 =,g' Makefile > 2 && echo "LIBTOOL = bash ./libtool" > 1 && cat 1 2 > Makefile
1012         touch libtest.c
1013
1014 EXTRA_DIST += bug-438454.cs bug-438454.exe.stdout.expected
1015 test-process-exit:
1016         @$(MCS) $(srcdir)/bug-438454.cs -out:bug-438454.exe
1017         @echo "Testing bug-438454.exe..."
1018         @$(RUNTIME) bug-438454.exe > bug-438454.exe.stdout
1019         @diff -w bug-438454.exe.stdout $(srcdir)/bug-438454.exe.stdout.expected
1020
1021 OOM_TESTS =     \
1022         gc-oom-handling.exe     \
1023         gc-oom-handling2.exe
1024
1025
1026 test-oom: $(OOM_TESTS)
1027         @for fn in $+ ; do      \
1028                 echo "Testing $$fn ...";        \
1029                 MONO_GC_PARAMS=max-heap-size=16m,major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1030                 MONO_GC_PARAMS=max-heap-size=16m MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1031                 MONO_GC_PARAMS=max-heap-size=16m                                                  $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1032         done
1033
1034
1035 noinst_LTLIBRARIES = libtest.la
1036
1037 INCLUDES = $(GLIB_CFLAGS) $(GMODULE_CFLAGS)
1038
1039 if HOST_WIN32
1040 # gcc-3.4.4 emits incorrect code when making indirect calls to stdcall functions using a tail call
1041 # This shows up when compiling mono_test_marshal_delegate ()
1042 libtest_la_CFLAGS=-fno-optimize-sibling-calls
1043 # the exported names created by gcc for stdcall functions are missing the leading _, so MS.NET
1044 # can't find them. So we use --kill-at to remove the @ suffix as well.
1045 libtest_la_LDFLAGS=-no-undefined -rpath `pwd` -Wl,--kill-at
1046 else
1047 libtest_la_LDFLAGS = -rpath `pwd`
1048 endif
1049 libtest_la_SOURCES = libtest.c
1050 libtest_la_LIBADD = $(GLIB_LIBS) $(LIBICONV)
1051
1052 CLEANFILES = $(TESTSI_CS) $(TESTSI_IL) $(STRESS_TESTS) *.dll *.stdout *.aotlog *.exe stest.dat